\section{Prelude to Survey Analysis}
\label{sec:Analysis}
In this section we describe a high level summary of the answers given by the 
HPC centers.

This section presents a high-level summary of the site responses to the survey, 
categorized into capabilities that each site is considering in the context of
research, technology development with the intent to eventually deploy into 
production, and those that are actively deployed into each site's production 
computing environment.
Due to the selection process described above, some sites may not have research 
or technology development efforts, however all sites have some type of 
production deployment of energy and power aware job scheduling and resource 
management in place.

\begin{table*}[bp]
  \caption{Part 1 of the summary of the answers from each center.}
  \begin{tabular}{|c|p{4.35cm}|p{5.7cm}|p{5cm}|}
    \hline
    \textbf{Center} & \textbf{Research Activities} & \textbf{Technology Development with Intent to Deploy} & \textbf{Production Development} \\
    \hline
    \hline
    \multirow{3}{*}[-10pt]{\centering \textbf{RIKEN}} & \multirow{3}{*}[-10pt]{\parbox{4cm}{Integrating job scheduler info with decision to use grid vs. gas turbine energy}} & \multirow{3}{*}[-10pt]{\parbox{5.5cm}{Power-aware job scheduling for Post-K, with Fujitsu}} & 3 days for large jobs each month \\
    \cline{4-4}
    & & & Automated emergency job killing if power limit exceeded \\
    \cline{4-4}
    & & & Pre-run estimate of power usage of each job, based on temperature \\
    \hline
    \hline
    \multirow{3}{*}[-40pt]{\centering \textbf{Tokyo Tech}} & \multirow{3}{*}[-40pt]{\parbox{4cm}{Activities to facilitate Production Development}} & \multirow{3}{*}[-40pt]{\parbox{5.5cm}{Inter-system power capping. TSUBAME2 and TSUBAME3 will need to share the facility power budget.}} & Resource manager dynamically boots or shuts down nodes to stay under 
    power cap (summer only, enforced over \~~30 min window). 
    Interacts with job scheduler to avoid killing jobs.
    NEC implemented, works cooperatively with PBS Pro. \\
    \cline{4-4}
    & & & Resource manager shuts down nodes that have been idle for a long time. \\
    \cline{4-4}
    & & & Uses virtual machines to split compute nodes.  (Complicates physical node shutdown.)\\
    \hline
    \hline
    \multirow{3}{*}[-40pt]{\textbf{CEA}} & Analyze collected power and energy info archived long term and use for EPA scheduling & Gives users mark on how well they used power and energy & Energy use provided to users at end of every job \\
    \cline{2-4}
    & Investigating how to use and apply \texttt{mpi\_yield\_when\_idle} & Together with BULL developing power adaptive scheduling in Slurm & \multirow{2}{*}[-20pt]{\parbox{5cm}{Manually shutting down nodes to shift po\-wer budget between systems}} \\
    \cline{2-3}
      & Investigating with BULL power capping and DVFS & Developing 'layout logic' in Slurm, be able to tell what PDUs/Chillers a node or rack depends on and avoid scheduling jobs on them when maintenance & \\
    \hline
    \hline
    \multirow{7}{*}{\textbf{KAUST}} & \multirow{4}{*}[-15pt]{\parbox{4.15cm}{Monitoring and managing power usage under data center power and cooling limits}} & \multirow{5}{*}[-10pt]{\parbox{5.5cm}{Analyzing and detecting most power hungry applications in production. Developing optimal power limit constraint strategy for users on Shaheen Cray XC40, while maintaining several HPC systems in production (BG/P and clusters)}} & Static power capping via Cray CAPMC. 30\% of nodes run uncapped, 70\% run with 270~W power cap. \\
    \cline{4-4}
    & & & Using Slurm Dynamic Power Management (SDPM) that interfaces with Cray CAPMC (KAUST worked with SchedMD to develop SDPM) \\
    \hline
    \hline
    \multirow{3}{*}[-25pt]{\textbf{LRZ}} & Investigating merging Slurm and GEOPM for system energy \& power control. & \multirow{3}{*}[-30pt]{\parbox{5.5cm}{Working on adding energy-aware scheduling capabilities to Slurm, similar to what they have with LoadLeveler today.}} & First time new app runs: characterized for frequency, runtime and energy. \\
    \cline{2-2} \cline{4-4} 
    & Investigating scheduling for power instead of energy & & Administrator selects job scheduling goal, energy to solution or best performance. \\
    \cline{2-2} \cline{4-4}
    & Linking job scheduler with IT infrastructure + cooling; scheduler may delay jobs when IT infrastructure is particularly inefficient & & LRZ worked with IBM on energy-aware scheduling support in LoadLeveler, now ported to LSF. \\
    \hline


    \label{tab:answers1}
  \end{tabular}
\end{table*}



\begin{table*}
  \caption{Part 2 of the summary of the answers from each center.}
  \begin{tabular}{|c|p{4.35cm}|p{5.7cm}|p{4.8cm}|}
    \hline
    \textbf{Center} & \textbf{Research Activities} & \textbf{Technology Development with Intent to Deploy} & \textbf{Production Development} \\
    \hline
    \hline
    \multirow{3}{*}[-30pt]{\textbf{STFC}} & IBM/LSF energy-aware scheduling is experimented with on small-scale (360 node) system & \multirow{3}{*}[-30pt]{\parbox{5.5cm}{Deployment of reporting tool for user power consumption at the job level. (Fine as well as coarse granularity)}} & \multirow{3}{*}[-30pt]{\parbox{4.8cm}{Continuously collecting power and energy system monitoring info, data center, machine, and job levels}} \\
    \cline{2-2}
    & Programmable interface (PowerAPI-based) for application power measurements of code segments (with interface to JSRM) & & \\
    \cline{2-2}
    & Investigation of power aware policies using higher level abstract e.g., GEOPM and Job Scheduler. & & \\
    \hline
    \hline
    \multirow{7}{*}{\parbox{1.5cm}{\centering\textbf{LANL \\+\\ Sandia}}} & \multirow{7}{*}{\parbox{4cm}{Analyzing power system monitoring info to assess potential of EPA scheduling, gather traces for evaluating EPA approaches.}} & EPA job scheduling support developed with Adaptive Inc. for Moab/Torque, interfaces with Cray CAPMC and Power API. Trinity is now using Slurm, but Moab work remains available for future use. & \multirow{7}{*}{\parbox{4.7cm}{Cray CAPMC power capping infrastructure, out-of-band control, administrator  ability to set system-wide and node-level power caps (available on all Cray XC  systems).}} \\
    \cline{3-3}
    & & Developed Power API implementation with Cray, utilized by Moab/Torque for EPA job scheduling. & \\
    \hline
    \hline
    \multirow{3}{*}[-10pt]{\textbf{CINECA}} & Scalable power monitoring, used to predict per-job power use and used to generate predictive models for node power and temperature evolution (with University of Bologna) & \multirow{3}{*}[-10pt]{\parbox{5.7cm}{Developing together with E4 EPA job scheduling support in Slurm. Also tracking EPA Slurm work being done by BULL and SchedMD.}} & \multirow{3}{*}[-10pt]{\parbox{4.7cm}{EPA job scheduling on Eurora system (now decommissioned) using PBSPro, collaboration with Altair}} \\
    \hline
      \multirow{6}{*}[-5pt]{\parbox{1.5cm}{\centering{\textbf{HCAHPC \\ (University of Tsukuba \\ and the University of Tokyo)}}}}
      & \multirow{6}{*}{\parbox{4cm}{Activities to facilitate Production Development.}} 
      & \multirow{6}{*}[-10pt]{\parbox{5.5cm}{--}} 
      & Ability to set power caps for groups of nodes via the resource manager (Fujitsu proprietary product)\\
    \cline{4-4}
    & & & Manual emergency response, admin sets power cap.\\
    \cline{4-4}
      & & & Delivering post-job energy use reports to users.\\
    \hline
    \label{tab:answers2}
  \end{tabular}
\end{table*}


The summary of the answers shown in Tables~\ref{tab:answers1} and~\ref{tab:answers2} provide a
short overview of the activities at the interviewed centers. 
This work will be followed by an in-depth analysis of the interviews, going into 
detail in regards to their solutions, the similarities, and applicability.
The reader should be reminded that the in depth analysis of the survey is not the primary focus of the work at hand. As mentioned in the abstract this division of scope allows for more in depth coverage of the results.  

% KTP -- is this paragraph necessary?  Is there some other way to cites these things without making it sound like they cover the material in this paper.
It should be mentioned that the undertaking of the survey was also presented as a poster submission at SC18~\cite{SC18poster}.
Additionally a short insight into points from Question 4 were given in an invited article by Siddhartha Jana on the insideHPC website~\cite{insideHPCSid}.
The full analysis will be synthesised from the raw material of the interview and whitepaper~\cite{whitepaper}
in an upcoming document with consensus of the \EEHPCWG \EPAJSRM team,
as soon as the full analysis is finished.


%(\hl{MP: I think it would be good to give very brief
%  analysis of the answer by mentioning which part of EPA JSRM in
%  Figure 1 are addressed by each center as that would show where the
%  focus is. I believe that some discussion of the results obtained is
%  necessary for the paper})


%%  LocalWords:  HPC centers categorized Center RIKEN Pre TSUBAME NEC
%%  LocalWords:  CEA Analyze mpi Slurm DVFS PDUs KAUST center Shaheen
%%  LocalWords:  Analyzing XC BG CAPMC SDPM SchedMD LRZ GEOPM runtime
%%  LocalWords:  LoadLeveler characterized LSF STFC PowerAPI JSRM API
%%  LocalWords:  LANL Sandia Moab utilized CINECA Scalable Eurora
%%  LocalWords:  PBSPro
